﻿Option Strict On

Imports System.Net

Public Class Form1

    ' AppData Ordner
    Dim AppData As String = Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData)

    ' Teeworlds Maps & Downloadedmaps Ordner
    Public Maps As String = AppData & "\Teeworlds\maps"
    Public Downloadedmaps As String = AppData & "\Teeworlds\downloadedmaps"

    Dim TotalMaps As Integer = 0

    Public Const MAPTYPE_STANDARD As Integer = 0
    Public Const MAPTYPE_DOWNLOADED As Integer = 1

    Structure Map
        Dim Type As Integer
        Dim Path As String
    End Structure

    Dim MapList As List(Of Map)

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
        Dim LoadThread As New Threading.Thread(AddressOf LoadMaps)
        LoadThread.Start()
    End Sub

    Sub LoadMaps()
        MapList = New List(Of Map)

        If IO.Directory.Exists(Maps) = False Then
            MsgBox(String.Format("Der Pfad zum Teeworlds-Map-Ordner existiert nicht: {0}.", Maps))
        End If
        If IO.Directory.Exists(Downloadedmaps) = False Then
            MsgBox(String.Format("Der Pfad zum Teeworlds-Downloadedmaps-Ordner existiert nicht: {0}.", Downloadedmaps))
        End If

        For Each Map As String In IO.Directory.GetFiles(Maps)
            TotalMaps += 1
        Next
        For Each DlMap As String In IO.Directory.GetFiles(Downloadedmaps)
            TotalMaps += 1
        Next

        Invoke(Sub() ProgressBar1.Maximum = TotalMaps)

        For Each Map As String In IO.Directory.GetFiles(Maps)

            Invoke(Sub() lStatus.Text = String.Format("Lade Map ({0}/{1}): {2}", ProgressBar1.Value, ProgressBar1.Maximum, IO.Path.GetFileName(Map)))

            Dim MapItem As New Map
            MapItem.Type = MAPTYPE_STANDARD
            MapItem.Path = Map
            MapList.Add(MapItem)

            Invoke(Sub() ProgressBar1.Increment(1))
        Next
        For Each Map As String In IO.Directory.GetFiles(Downloadedmaps)

            Invoke(Sub() lStatus.Text = String.Format("Lade Map ({0}/{1}): {2}", ProgressBar1.Value, ProgressBar1.Maximum, IO.Path.GetFileName(Map)))

            Dim MapItem As New Map
            MapItem.Type = MAPTYPE_DOWNLOADED
            MapItem.Path = Map
            MapList.Add(MapItem)

            Invoke(Sub() ProgressBar1.Increment(1))
        Next

        Invoke(Sub() Form2.Load(MapList))
        Invoke(Sub() Me.Hide())
    End Sub
End Class
